(* Analyse syntaxique d'expression algbrique infixe avec priorit et parenthsage *)

#open "genlex";;

(* Transformation d'un flux en liste *)
let rec list_of_stream = function
	| [< 't; list_of_stream q >] -> t::q
	| [< >] -> []
;;

(* Lit les expressions dans un fichier et leur applique la fonction d'analyse syntaxique qui doit
   tre du type (an_syn: token list -> bool * token list). *)
let analyse_file (an_syn: token list -> bool * token list) fichier =
  let canal = open_in fichier
  and raccourci s = list_of_stream (make_lexer ["+";"-";"*";"/";"(";")";"#"] (stream_of_string s))
  and ligne = ref [] and result = ref (true, []) and test = ref true
  in 
    while !test do
      (try ligne := raccourci ((input_line canal)^" #") with End_of_file -> test := false) ;
      if (!test) then
        begin
          result := an_syn !ligne ;
          print_string (string_of_toklist !ligne); print_newline();
          if (fst !result)
          then print_string "L'expression est correcte."
          else print_string ("L'expression est incorrecte  partir de "^(string_of_toklist (snd !result)));
          print_newline(); 
        end;
    done;
    close_in canal;
;;

analyse_file lit_ligne "C:\Documents and Settings\Mathieu\Mes documents\Colles_CaML\Colle05\essai.don";;
